unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils
  , LR_PQConnection
  , LR_IBConnection
  , LRDialogControls
  ,LR_Class, LR_Desgn, LR_DBSet
  , Forms, Controls, Graphics, Dialogs,
  StdCtrls, sqldb, SQLite3Conn,inifiles;
//LR_View,

type

  { TForm1 }

  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    frDBDataSet1: TfrDBDataSet;
    frDesigner1: TfrDesigner;
    frReport1: TfrReport;
    ListBox1: TListBox;
    LRDialogControls1: TLRDialogControls;
    LR_IBConnection1: TLR_IBConnection;
    SQLConnector1: TSQLConnector;
    SQLQuery1: TSQLQuery;
    SQLTransaction1: TSQLTransaction;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    FReportFolders:string;
    FBaseFileName:string;
    procedure RefreshReportList;
    function CurReportName:string;
    procedure LoadData;
    procedure ReadIniFile;
  public
    { public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

uses
  LazFileUtils;

{ TForm1 }

procedure TForm1.FormCreate(Sender: TObject);
begin
  FReportFolders:=ExtractFileDir(ParamStr(0)) + DirectorySeparator + 'reports';
  RefreshReportList;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  RefreshReportList;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  if (ListBox1.Items.Count>0) and (ListBox1.ItemIndex>-1) and (ListBox1.ItemIndex<ListBox1.Items.Count) then
  begin
    LoadData;
    frReport1.LoadFromFile(CurReportName);
    frReport1.ShowReport;
  end
  else
    ShowMessage('Please select a report');
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
  LoadData;
  frReport1.LoadFromFile(CurReportName);
  frReport1.DesignReport;
  RefreshReportList;
end;

procedure TForm1.RefreshReportList;
var
  R:TSearchRec;
  Code:integer;
begin
  ListBox1.Clear;
  Code:=FindFirstUTF8(FReportFolders+DirectorySeparator+'*.lrf', faAnyFile, R);
  while Code = 0 do
  begin
    if R.Attr and faDirectory = 0 then
    begin
      ListBox1.Items.Add(R.Name);
    end;
    Code:=FindNextUTF8(R);
  end;
  FindCloseUTF8(R);
end;

function TForm1.CurReportName: string;
begin
  Result:=FReportFolders + DirectorySeparator;
  if (ListBox1.Items.Count>0) and (ListBox1.ItemIndex>-1) and (ListBox1.ItemIndex<ListBox1.Items.Count) then begin
    LoadData;
    Result:=Result + ListBox1.Items[ListBox1.ItemIndex];
  end
  else
    Result:=Result + 'New_Report.lrf';
end;

procedure TForm1.LoadData;
var
  sl:TStringlist;
begin
  FBaseFileName:=ExtractFileNameOnly(ListBox1.Items[ListBox1.ItemIndex]);

  SQLConnector1.Close();
  ReadIniFile;
  SQLConnector1.Open;

  sl:=TStringList.Create;
  try
    sl.LoadFromFile(FReportFolders+ DirectorySeparator + FBaseFileName +'.sql');
    SQLQuery1.Close;
    SQLQuery1.SQL.Text:=sl.Text;
    SQLQuery1.Open;
  finally
    freeandnil(sl);
  end;

end;

procedure TForm1.ReadIniFile;
var
  sIniFileName:string;
  oIniFile:TIniFile;
  sDBname:string;
begin
  sIniFileName:=FReportFolders+ DirectorySeparator + FBaseFileName+'.ini';

  if FileExists(sIniFileName) then
  begin
    try
      oIniFile:= TIniFile.Create(sIniFileName);
      SQLConnector1.HostName:=oIniFile.ReadString('Database','Server','');
      SQLConnector1.username:=oIniFile.ReadString('Database','Username','');
      SQLConnector1.password:=oIniFile.ReadString('Database','Password','');

      sDBname:=FReportFolders+ DirectorySeparator + oIniFile.ReadString('Database','DatabaseName','data.db');

      if not FileExists(sDBname) then Showmessage('Database File does not exist'+LineEnding+sDBName);
      SQLConnector1.DatabaseName:=sDBName;

      SQLConnector1.ConnectorType:=oIniFile.ReadString('Database','ConnectorType','SQLite3');
    finally
      freeandnil(oIniFile);
    end;
  end
  else
  begin
    SQLConnector1.HostName:='';
    SQLConnector1.username:='';
    SQLConnector1.password:='';
    SQLConnector1.DatabaseName:='data.db';
    SQLConnector1.ConnectorType:='SQLite3';
  end;

end;

end.

